#include <bits/stdc++.h>

using namespace std;

#define MAXN 16

int n = 4;          // number of queens
int solutions = 0;  // number of solutions (must be 0 when the search starts)
bool column[MAXN], diag1[2*MAXN - 1], diag2[2*MAXN - 1];    // invalid positions (must be all false when the search starts)

void search(int y = 0) {
    if(y == n) { solutions++; return; }
    for(int x = 0; x < n; x++) {
        if(column[x] || diag1[x+y] || diag2[x-y+n-1]) continue;
        column[x] = diag1[x+y] = diag2[x-y+n-1] = true;
        search(y + 1);
        column[x] = diag1[x+y] = diag2[x-y+n-1] = false;
    }
}

int main() {
    for(n = 1; n <= MAXN; n++, solutions = 0) {
        clock_t start_time = clock();
        search();
        clock_t elapsed_time = clock() - start_time;
        cout << "n = " << n << "\n\tsolutions = " << solutions << "\n\ttime (s) = " << fixed << static_cast<double>(elapsed_time) / CLOCKS_PER_SEC << endl;
    }
    return 0;
}
