#include <bits/stdc++.h>

using namespace std;

#ifdef TEST
#   define DEBUG(x) cout << (x) << endl
#else
#   define DEBUG(x)
#endif

bool ends_first(const tuple<string,int,int>& a, const tuple<string,int,int>& b) {
    return get<2>(a) < get<2>(b);
}

void schedule(vector<tuple<string,int,int>> events, vector<string>& res) {
    sort(events.begin(), events.end(), ends_first);
    for(int i = 0, free = 0; i < events.size(); i++) {
        if(get<1>(events[i]) < free) continue;
        res.push_back(get<0>(events[i]));
        free = get<2>(events[i]);
    }
}

int main() {
    vector<string> res;
    schedule({{"A",1,3}, {"B",2,5}, {"C",3,9}, {"D",6,8}}, res);
    for(auto x : res) cout << x << " ";
    cout << endl;
    return 0;
}

